// 获取光标位置
import $ from 'jquery'
export default function getSelectionType(editor) {
    let type = null;
    let attach = null;
    let isCollapsed = null;
    let blocks = null;
    let $activeDom = $(document.activeElement)
    if ($activeDom.attr('id') == 'titleArea') {
        // 在标题栏
        type = 'title'
    } else if ($activeDom.attr('id') == 'mytextarea' && editor != null) {
        // 在编辑区
        isCollapsed = editor.selection.isCollapsed();
        blocks = editor.selection.getSelectedBlocks();
        let getRng = editor.selection.getRng();
        let startOffset = editor.selection.getRng().startOffset;
        if (isCollapsed) {
            //只有光标
            if (
                blocks.length == 1 &&
                $(blocks[0]).attr("data-image") == "imgBox"
            ) {
                if (startOffset == 0) {
                    // 在图片行前
                    type = "imgBefore";
                } else {
                    // 在图片行后
                    type = "imgAfter";
                }
            } else if (
                blocks.length == 1 &&
                startOffset == 0 &&
                $(blocks[0]).prev().length != 0 &&
                $(blocks[0]).prev().attr("data-image") == "imgBox"
            ) {
                // 图片下一行
                type = "afterImg";
            } else if (
                blocks.length == 1 &&
                getRng.commonAncestorContainer.length == startOffset &&
                $(blocks[0]).next().length != 0 &&
                $(blocks[0]).next().attr("data-image") == "imgBox"
            ) {
                // 图片上一行
                type = "beforeImg";
            } else if (
                $(blocks[0]).prev().length &&
                $(blocks[0]).prev().attr('data-type-flag') == 'voice'
            ) {
                // 在语音行后
                type = "voiceAfter";
            } else if (
                $(blocks[0]).next().length &&
                $(blocks[0]).next().attr('data-type-flag') == 'voice'
            ) {
                // 在语音行前
                type = "voiceBefore";
            }
        } else {
            //  有选区
            let isAllImg = blocks.every(item => $(item).attr('data-image') == 'imgBox');
            if (isAllImg) {
                // 选区全是图片
                type = "allimg"
                if (blocks.length == 1) {
                    attach = 'one'
                } else {
                    attach = 'more'
                }
            } else if (blocks.length == 1 && $(blocks[0]).attr('data-type-flag') == 'voice') {
                // 其他
                type = 'allvoice'
                attach = 'one'
            }


        }
    }

    return {
        type,
        isCollapsed,
        blocks,
        attach
    };
}


