import $ from 'jquery'
/**
 * 获取光标Y轴位置
 * @date 2022-05-19
 * @param {any} element 可编辑dom
 * @returns {number} Y轴位置,高度
 */
function getCursortPosition(element) {
    const Padding = 8
    let focusY = 0;
    let fontHeight = 0;
    let doc = element.ownerDocument || element.document;
    let win = doc.defaultView || doc.parentWindow;
    let sel = win.getSelection();
    if (sel.rangeCount > 0) {
        let range = win.getSelection().getRangeAt(0);
        let span = document.createElement("span");
        $(span).attr('style', ' width: 0;height: 0px;vertical-align: bottom;')
        range.insertNode(span);
        fontHeight = $(span).css("fontSize").slice(0, -2) - 0 + Padding * 2;
        focusY =
            $(span).offset().top +
            $("#contentBox").scrollTop() -
            document.querySelector("#contentBox").offsetTop;
        $(span).remove();
    }
    return { focusY, fontHeight };
}

/**
 * 页面滚动到光标位置
 * @date 2022-05-19
 * @returns {any}
 */
export default function setFocusScroll() {
    let { focusY, fontHeight } = getCursortPosition(
        document.querySelector("#contentBox")
    );
    let scrollTop = $("#contentBox").scrollTop();
    let viewY = $("#contentBox").height() + scrollTop;
    if (focusY < scrollTop) {
        $("#contentBox").scrollTop(focusY - fontHeight);
    } else if (focusY + fontHeight > viewY) {
        $("#contentBox").scrollTop(
            focusY - $("#contentBox").height() + fontHeight
        );
    }
}